/* begin_generated_IBM_copyright_prolog                             */
/*                                                                  */
/* This is an automatically generated copyright prolog.             */
/* After initializing,  DO NOT MODIFY OR MOVE                       */
/* ---------------------------------------------------------------- */
/* IBM Confidential                                                 */
/*                                                                  */
/* OCO Source Materials                                             */
/*                                                                  */
/* Product(s):                                                      */
/*     IBM.Systems.Management                                       */
/*                                                                  */
/* (C)Copyright IBM Corp.  2004, 2008                               */
/*                                                                  */
/* The Source code for this program is not published  or otherwise  */
/* divested of its trade secrets,  irrespective of what has been    */
/* deposited with the U.S. Copyright Office.                        */
/*  --------------------------------------------------------------- */
/*                                                                  */
/* end_generated_IBM_copyright_prolog                               */
/********************************************************************/
/********************************************************************/
/* sysinfo   .cpp                                                   */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* This file contains the implementation of the main program for    */
/* the retrieval of MTMS information from i5OS.  This program will  */
/* will call into the HRI api's to retrieve this info.              */
/*                                                                  */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/*                                                                  */
/* Change Activity:                                                 */
/*                                                                  */
/* Flag Reason    Version  Date   User     Comment                  */
/* ---- --------  -------  ------ -------  ------------------------ */
/* $A0  Dxxxxx    1.1.0    091907 btang    New file                 */
/********************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <errno.h>

#include "as400_types.h"
#include "as400_protos.h"


char EtoAchars[256] = {
'\000','\001','\002','\003','\032','\011','\032','\177',
'\032','\032','\032','\013','\014','\015','\016','\017',
'\020','\021','\022','\023','\032','\012','\010','\032',
'\030','\031','\032','\032','\034','\035','\036','\037',
'\032','\032','\034','\032','\032','\012','\027','\033',
'\032','\032','\032','\032','\032','\005','\006','\007',
'\032','\032','\026','\032','\032','\036','\032','\004',
'\032','\032','\032','\032','\024','\025','\032','\032',
'\040','\246','\341','\200','\353','\220','\237','\342',
'\253','\213','\233','\056','\074','\050','\053','\174',
'\046','\251','\252','\234','\333','\245','\231','\343',
'\250','\236','\041','\044','\052','\051','\073','\136',
'\055','\057','\337','\334','\232','\335','\336','\230',
'\235','\254','\272','\054','\045','\137','\076','\077',
'\327','\210','\224','\260','\261','\262','\374','\326',
'\373','\140','\072','\043','\100','\047','\075','\042',
'\370','\141','\142','\143','\144','\145','\146','\147',
'\150','\151','\226','\244','\363','\257','\256','\305',
'\214','\152','\153','\154','\155','\156','\157','\160',
'\161','\162','\227','\207','\316','\223','\361','\376',
'\310','\176','\163','\164','\165','\166','\167','\170',
'\171','\172','\357','\300','\332','\133','\362','\371',
'\265','\266','\375','\267','\270','\271','\346','\273',
'\274','\275','\215','\331','\277','\135','\330','\304',
'\173','\101','\102','\103','\104','\105','\106','\107',
'\110','\111','\313','\312','\276','\350','\354','\355',
'\175','\112','\113','\114','\115','\116','\117','\120',
'\121','\122','\241','\255','\365','\364','\243','\217',
'\134','\347','\123','\124','\125','\126','\127','\130',
'\131','\132','\240','\205','\216','\351','\344','\321',
'\060','\061','\062','\063','\064','\065','\066','\067',
'\070','\071','\263','\367','\360','\372','\247','\377' };

char AtoEchars[256] = {
'\000','\001','\002','\003','\067','\055','\056','\057',
'\026','\005','\045','\013','\014','\015','\016','\017',
'\020','\021','\022','\023','\074','\075','\062','\046',
'\030','\031','\077','\047','\042','\035','\065','\037',
'\100','\132','\177','\173','\133','\154','\120','\175',
'\115','\135','\134','\116','\153','\140','\113','\141',
'\360','\361','\362','\363','\364','\365','\366','\367',
'\370','\371','\172','\136','\114','\176','\156','\157',
'\174','\301','\302','\303','\304','\305','\306','\307',
'\310','\311','\321','\322','\323','\324','\325','\326',
'\327','\330','\331','\342','\343','\344','\345','\346',
'\347','\350','\351','\255','\340','\275','\137','\155',
'\171','\201','\202','\203','\204','\205','\206','\207',
'\210','\211','\221','\222','\223','\224','\225','\226',
'\227','\230','\231','\242','\243','\244','\245','\246',
'\247','\250','\251','\300','\117','\320','\241','\007',
'\000','\001','\002','\003','\067','\055','\056','\057',
'\026','\005','\045','\013','\014','\015','\016','\017',
'\020','\021','\022','\023','\074','\075','\062','\046',
'\030','\031','\077','\047','\042','\035','\065','\037',
'\100','\132','\177','\173','\133','\154','\120','\175',
'\115','\135','\134','\116','\153','\140','\113','\141',
'\360','\361','\362','\363','\364','\365','\366','\367',
'\370','\371','\172','\136','\114','\176','\156','\157',
'\174','\301','\302','\303','\304','\305','\306','\307',
'\310','\311','\321','\322','\323','\324','\325','\326',
'\327','\330','\331','\342','\343','\344','\345','\346',
'\347','\350','\351','\255','\340','\275','\137','\155',
'\171','\201','\202','\203','\204','\205','\206','\207',
'\210','\211','\221','\222','\223','\224','\225','\226',
'\227','\230','\231','\242','\243','\244','\245','\246',
'\247','\250','\251','\300','\117','\320','\241','\007' };

typedef struct RequestCriteria_ {
    char ResourceName[32];
    char Handle[16];
    int SearchRequest;
    int KeyOffset;
    int NumberOfKeys;
    int Key;
} RequestCriteria_T;

typedef struct RTVI0100_ {
    int BytesReturned;
    int BytesAvailable;
    int NumberOfEntries;
    int RecordLength;
    int Key;
    int DataLength;
    char Buffer[200];
} RTVI0100_T;

typedef struct PartitionInfo_ {
    char Buffer1[40];
    int LPARNumber;
    char Buffer2[356];
} PartitionInfo;

typedef struct ErrorCode_ {
    int BytesProvided;
    int BytesAvailable;
    char MessageId[7];
    char Padding;
    char Buffer[500];
} ErrorCode_T;

#define ROUND_QUAD(x) (((size_t)(x) + 0xf) & ~0xf)


////////////////////////////////////////////////////
//  convertCodeSet
////////////////////////////////////////////////////
void convertCodeSet(char* buffer, unsigned size, const char* codeSetMap)
{
    for (int i=0; i<size; i++)
        buffer[i] = codeSetMap[buffer[i]];  
}

////////////////////////////////////////////////////
//  fixUpValue
////////////////////////////////////////////////////
void fixUpValue(char key, char* value, int length)
{
    // Get rid of the dash from the serial number after the plant
    if (key == 0x04) {
        if (value[2] == 0x2D) {
            int realLen = strlen(value);
            for(int i=3; i<=realLen; i++)
                value[i-1] = value[i];
        }
    }
    // Strip off any trailing spaces
    for(int i=length; i>0; i--) {
        if (value[i-1] != 0x00 && value[i-1] != 0x20)
            break;
        value[i-1] = 0x00;
    }
}

////////////////////////////////////////////////////
//  getSrvpgmProcEntryPoint
////////////////////////////////////////////////////
ILEpointer* getSrvpgmProcEntryPoint(const char* srvpgm, const char* procedure)
{
    int actmark = 0;
    ILEpointer* ileTarget = NULL;

    // Find the activation entry for the provided service program
    if ((actmark = _ILELOAD((char*)srvpgm, ILELOAD_LIBOBJ)) == -1) {
        printf("Failed - Loading Service Program\n");
        return NULL;
    }
        
    char* ileTargetBuf = new char[sizeof(ILEpointer)+15];
    ileTarget = (ILEpointer*)ROUND_QUAD(ileTargetBuf);

    // Look up the symbol within the service program found
    if (_ILESYM(ileTarget, actmark, procedure) == -1) {
        printf("Failed - Looking up Symbole\n");
        return NULL;
    }
    return ileTarget;
}

////////////////////////////////////////////////////
//  callQRZRRSI
////////////////////////////////////////////////////
int callQRZRRSI(const char* rscName, char key, char* outputVal, int outputLength, int printError)
{
    // Program Pointer will contain the OS/400 16-byte tagged system pointer to the program
    char* buffer[6];
    char format[9];
    RTVI0100_T receiver;
    ErrorCode_T errorCode;
    ILEpointer pgm_pointer;
    RequestCriteria_T criteria;
    int receiverLen = sizeof(RTVI0100_T);

    memset(&errorCode,0x00, 516);
    errorCode.BytesProvided = 516;

    // Initialize everything to zeros to start out
    memset(&receiver, 0x00, sizeof(RTVI0100_T));
    memset(&criteria, 0x00, sizeof(RequestCriteria_T));

    // Set up the input criteria pointing to the System Resource
    memset(criteria.Handle, 0x00, 16);
    sprintf(criteria.ResourceName, "%-32.32s", rscName);
    criteria.NumberOfKeys = 1;
    criteria.SearchRequest = 1;
    criteria.KeyOffset = 60;
    criteria.Key = key;

    sprintf(format,"RTVI0100");
    convertCodeSet(format, 8, AtoEchars);
    convertCodeSet(criteria.ResourceName, 32, AtoEchars);

    // Set up the parameter buffer that is to be used to call the program
    buffer[0] = (char*)&receiver;
    buffer[1] = (char*)&receiverLen;
    buffer[2] = format;
    buffer[3] = (char*)&criteria;
    buffer[4] = (char*)&errorCode;
    buffer[5] = NULL;

    // Set the OS/400 pointer to the *PGM object 
    int rc1 = _RSLOBJ2(&pgm_pointer, RSLOBJ_TS_PGM, "QRZRRSI", "QSYS");

    // Call the OS/400 API from OS/400 PASE 
    int rc2 = _PGMCALL(&pgm_pointer, (void**)buffer, 0);

    if (errorCode.BytesAvailable > 0) {
        if (printError) {
          convertCodeSet(errorCode.MessageId, 7, EtoAchars);
          printf("Error on %c: %7.7s\n", key, errorCode.MessageId);
        }
        return -1;
    }

    // Make sure something is returned before printing it out
    if (receiver.NumberOfEntries >= 1) {
        convertCodeSet(receiver.Buffer, outputLength, EtoAchars);
        fixUpValue(key, receiver.Buffer, outputLength);
        memcpy(outputVal, receiver.Buffer, 200);
    }

    return receiver.NumberOfEntries;
}

////////////////////////////////////////////////////
//  retrieveProperty
////////////////////////////////////////////////////
void retrieveProperty(const char* propName, char key, int length)
{
    char outputVal[200];

    if (callQRZRRSI("SYS01", key, outputVal, length, 0) < 0)
        if (callQRZRRSI("CEC01", key, outputVal, length, 1) < 1)
            return;
    
    printf("%s=%s\n", propName, outputVal);
}

////////////////////////////////////////////////////
//  retrieveLPARID
////////////////////////////////////////////////////
void retrieveLPARID()
{
    ILEpointer* ileTarget = getSrvpgmProcEntryPoint("QSYS/QPMLPMGT", "dlpar_get_info");
    // Error should have already been logged
    if (ileTarget == NULL)
        return;

    char buffer[32];
    PartitionInfo info;
    PartitionInfo* infoP = &info;
    short resultType = RESULT_INT32;
    int format = 1, dataLen = sizeof(PartitionInfo);
    int16 signature[] = { ARG_MEMPTR, ARG_INT32, ARG_INT32, ARG_END };

    memset(&info, 0x00, sizeof(PartitionInfo));
    memcpy(buffer, &infoP, sizeof(char*));
    memcpy(buffer+sizeof(char*), &format, 4);
    memcpy(buffer+sizeof(char*)+4, &dataLen, 4);

    // XLC does not guarantee 16-byte alignment for stack variables, but PASE malloc
    // always returns 16-byte aligned storage, so determine the size needed to 16-byte align
    ILEarglist_base* ileArgList = (ILEarglist_base*)malloc(size_ILEarglist(signature));

    // Build the argument list into an ILE arg list buffer adhering to the signature provided
    build_ILEarglist(ileArgList, buffer, signature);

    // If an exception or signal occurs, the heap allocation is orphaned(storage leak)
    _ILECALL(ileTarget, ileArgList, signature, resultType);

    // If the Return Code is bad, print out what the failure was
    if (ileArgList->result.s_int32.r_int32 < 0)
        printf("Failed - Error invoking Service Program API: %d\n", ileArgList->result.s_int32.r_int32);
    else
        printf("LPARID=%d\n", info.LPARNumber);

    free((char*)ileArgList);
}

////////////////////////////////////////////////////
//  main
////////////////////////////////////////////////////
int main (int argc, char *argv[])
{
    retrieveProperty("MachineType", 0x03, 10);
    retrieveProperty("ModelNumber", 0x05, 10);
    retrieveProperty("SystemSerialNumber", 0x04, 10);
    retrieveLPARID();
    return 0;
}


